indir='/odyssey/proxy/bpierce/Satellite/TROPOMI/'
openr,1,'tropomi.fil'
nfiles=0
readf,1,nfiles
for nf=0,nfiles-1 do begin
infile=''
readf,1,infile
result=str_sep(infile,'____')
syr=strmid(result(1),0,4)
smn=strmid(result(1),4,2)
sdy=strmid(result(1),6,2)
hrmnsc=strmid(result(1),9,6)
shr=strmid(hrmnsc,0,2)
smn=strmid(hrmnsc,2,2)
ssc=strmid(hrmnsc,4,2)
shr=shr+':'+smn+':'+ssc
;2011070118
year=long(syr)
month=long(smn)
day=long(sdy)
hour=long(hrmnsc)
print,infile
jday0=julday(1l,1l,year,0l,0l,0l)
jday=julday(month,day,year,0l,0l,0l)-jday0+1.
;print,jday
result=str_sep(string(jday),'.')
sjd=strtrim(result(0),2)
if jday lt 10 then sjd='00'+sjd
if jday lt 100 then sjd='0'+sjd
;
result=H5F_IS_HDF5(indir+infile)

if result eq 1 then begin 

; Open HDF5-based file
file_id=H5F_OPEN(indir+infile)

;result=H5_BROWSER(infile)
;stop

;result=H5_PARSE(infile)
;help,result,/structure
;stop

;           0:   DETAILED_RESULTS
;           1:   GEOLOCATIONS
;           2:   INPUT_DATA
param4='/PRODUCT/'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor
;           0:   SUPPORT_DATA
;           1:   air_mass_factor_total
;           2:   air_mass_factor_troposphere
;           3:   averaging_kernel
;           4:   corner
;           5:   delta_time
;           6:   ground_pixel
;           7:   intensity_offset_polynomial_exponents
;           8:   latitude
;           9:   layer
;          10:   longitude
;          11:   nitrogendioxide_tropospheric_column
;          12:   nitrogendioxide_tropospheric_column_precision
;          13:   nitrogendioxide_tropospheric_column_precision_kernel
;          14:   polynomial_exponents
;          15:   qa_value
;          16:   scanline
;          17:   time
;          18:   time_utc
;          19:   tm5_constant_a
;          20:   tm5_constant_b
;          21:   tm5_tropopause_layer_index
;          22:   vertices
;stop
index=8
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
latitude=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(latitude),', min=',min(latitude)
help,latitude
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=10
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
longitude=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(longitude),', min=',min(longitude)
help,longitude
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=11
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
nitrogendioxide_tropospheric_column=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(nitrogendioxide_tropospheric_column),', min=',min(nitrogendioxide_tropospheric_column)
help,nitrogendioxide_tropospheric_column
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=15
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
qa_value=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(qa_value),', min=',min(qa_value)
help,qa_value
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id


param4='/PRODUCT/SUPPORT_DATA/GEOLOCATIONS'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor
;           0:   geolocation_flags
;           1:   latitude_bounds
;           2:   longitude_bounds
;           3:   satellite_altitude
;           4:   satellite_latitude
;           5:   satellite_longitude
;           6:   satellite_orbit_phase
;           7:   solar_azimuth_angle
;           8:   solar_zenith_angle
;           9:   viewing_azimuth_angle
;          10:   viewing_zenith_angle
index=1
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
latitude_bounds=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(latitude_bounds),', min=',min(latitude_bounds)
help,latitude_bounds
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=2
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
longitude_bounds=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(longitude_bounds),', min=',min(longitude_bounds)
help,latitude_bounds
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id

param4='/PRODUCT/SUPPORT_DATA/DETAILED_RESULTS'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor
;           0:   air_mass_factor_stratosphere
;           1:   chi_square
;           2:   cloud_fraction_crb_nitrogendioxide_window
;           3:   cloud_radiance_fraction_nitrogendioxide_window
;           4:   degrees_of_freedom
;           5:   intensity_offset_coefficients
;           6:   intensity_offset_coefficients_precision
;           7:   nitrogendioxide_ghost_column
;           8:   nitrogendioxide_slant_column_density
;           9:   nitrogendioxide_slant_column_density_precision
;          10:   nitrogendioxide_stratospheric_column
;          11:   nitrogendioxide_stratospheric_column_precision
;          12:   nitrogendioxide_summed_total_column
;          13:   nitrogendioxide_summed_total_column_precision
;          14:   nitrogendioxide_total_column
;          15:   nitrogendioxide_total_column_precision
;          16:   nitrogendioxide_total_column_precision_kernel
;          17:   number_of_iterations
;          18:   number_of_spectral_points_in_retrieval
;          19:   oxygen_oxygen_dimer_slant_column_density
;          20:   oxygen_oxygen_dimer_slant_column_density_precision
;          21:   ozone_slant_column_density
;          22:   ozone_slant_column_density_precision
;          23:   polynomial_coefficients
;          24:   polynomial_coefficients_precision
;          25:   processing_quality_flags
;          26:   ring_coefficient
;          27:   ring_coefficient_precision
;          28:   root_mean_square_error_of_fit
;          29:   water_liquid_slant_column_density
;          30:   water_liquid_slant_column_density_precision
;          31:   water_slant_column_density
;          32:   water_slant_column_density_precision
;          33:   wavelength_calibration_chi_square
;          34:   wavelength_calibration_irradiance_chi_square
;          35:   wavelength_calibration_irradiance_offset
;          36:   wavelength_calibration_irradiance_offset_precision
;          37:   wavelength_calibration_offset
;          38:   wavelength_calibration_offset_precision
;          39:   wavelength_calibration_stretch
;          40:   wavelength_calibration_stretch_precision
index=3
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
cloud_radiance_fraction=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(cloud_radiance_fraction),', min=',min(cloud_radiance_fraction)
help,cloud_radiance_fraction
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=10
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
nitrogendioxide_stratospheric_column=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(nitrogendioxide_stratospheric_column),', min=',min(nitrogendioxide_stratospheric_column)
help,nitrogendioxide_stratospheric_column
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=14
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
nitrogendioxide_total_column=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(nitrogendioxide_total_column),', min=',min(nitrogendioxide_total_column)
help,nitrogendioxide_total_column
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
stop

;stop
endif; HDF5 check
endfor
close,2
end

